/*
 *  PhongImageMaterial.h
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/12/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PHONGIMAGEMATERIAL_H
#define PHONGIMAGEMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"

class PhongImageMaterial : public Material {
	public:
		PhongImageMaterial(const char* newFileName, double newKdiffuse, double newKambient,
					   const Color &newSpecColor, int newPhongTerm);
		virtual ~PhongImageMaterial() {}
		
		virtual void preprocess() {}
		
		void shade(Color &result, const RenderContext &context,
				   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
	
	
	private:
		Image *imageFile;
		double Kambient;
		double Kdiffuse;
		Color specColor;
		int phongTerm;
};

#endif