/*
 *  PointLight.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef POINTLIGHT_H
#define POINTLIGHT_H

#include "Vector.h"
#include "Color.h"
#include "Light.h"

class PointLight : public Light {
	public:
		PointLight(const Point &newPosition, const Color &newLightColor);
		virtual ~PointLight();
		
		virtual void preprocess();
		virtual double getLight(Color &color, Vector &lightDirection, const RenderContext &context,
							  const Point &location) const;
		
		PointLight(const PointLight &pl);
		PointLight &operator=(const PointLight &pl);
	
	private:
		Point position;
		Color lightColor;
};



#endif
