/*
 *  Primitive.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/30/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PRIMITIVE_H
#define PRIMITIVE_H

#include "Object.h"
#include "Vector.h"
#include "Material.h"
#include "Ray.h"
#include "HitRecord.h"

//class Material;

class Primitive : public Object {
	public:
		Primitive();
		Primitive(Material *newMaterial);
		virtual ~Primitive();
		
		virtual void preprocess();
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const = 0;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit,
							const RenderContext &context, const Ray &ray) const = 0;
		virtual void getTextCoord(Vector &textCoord, const RenderContext &context, const Ray &ray, const HitRecord &hit) const;
		
		Primitive(const Primitive &p);
		Primitive &operator=(const Primitive &p);
		
//	protected:
		Material *material;
};





#endif