/*
 *  SpherePolar.cpp
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/16/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "SpherePolar.h"

SpherePolar::SpherePolar(Material *mat, const Point &newCenter, double newRadius, const Vector &newPole, const Vector &newMeridian) :
						Sphere(mat, newCenter, newRadius), x(newMeridian), y(cross(newPole, newMeridian)), z(newPole)
 {
	x.normalize();
	y.normalize();
	z.normalize();
 }

void SpherePolar::getTextCoord(Vector &textCoord, const RenderContext &context, const Ray &ray, const HitRecord &hit) const
 {
	 Point hitPoint = ray.origin + ray.direction * hit.getT();
	 Vector p = hitPoint - center;
	 
	 double _x = dot(p, x);
	 double _y = dot(p, y);
	 double _z = dot(p, z);
	 
	 double r = sqrt(_x * _x + _y * _y + _z * _z);
	 double theta = atan2(_y, _x);
	 //theta *= 1.0 / 
	 double u = theta / (2 * M_PI);
	 if (u < 0)
		 u += 1;
	
	 double phi = acos(_z / r);
	 double v = 1.0 - (phi / M_PI);
	 textCoord = Vector(u, v, r);
	 
 }
