/*
 *  TileMaterial.cpp
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/16/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "TileMaterial.h"

TileMaterial::TileMaterial(const Point &newP1, const Vector &newV1,
								 const Vector &newV2, Material *newMaterial1,
								 Material *newMaterial2, double newGrout) :
p1(newP1), v1(newV1), v2(newV2), v3(0.0, 0.0, 0.0), grout(newGrout)
{
	material1 = newMaterial1;
	material2 = newMaterial2;
	v1 = v1 / v1.lengthSquared();
	v2 = v2 / v2.lengthSquared();							 
}

void TileMaterial::shade(Color &result, const RenderContext &context,
							const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const
{
	Vector textCoord;
	
	hit.getPrimitive()->getTextCoord(textCoord, context, ray, hit);

	double s = dot(textCoord, v1) - Floor(dot(textCoord, v1));
	double t = dot(textCoord, v2) - Floor(dot(textCoord, v2));
		
	if (s < grout || t < grout)
		material1->shade(result, context, ray, hit, depth, attenuation);
	else
		material2->shade(result, context, ray, hit, depth, attenuation);
}
